VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_write_excel"
   ClientHeight    =   1320
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8055
   LinkTopic       =   "Form1"
   ScaleHeight     =   1320
   ScaleWidth      =   8055
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdWrite 
      Caption         =   "Write"
      Default         =   -1  'True
      Height          =   495
      Left            =   3480
      TabIndex        =   2
      Top             =   600
      Width           =   1215
   End
   Begin VB.TextBox txtFile 
      Height          =   285
      Left            =   480
      TabIndex        =   1
      Top             =   120
      Width           =   7455
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "File:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   285
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Add a reference to "Microsoft Excel 11.0 Object Library"
' (or whatever version you have installed on your system).

Private Sub Form_Load()
Dim file_name As String

    file_name = Application.StartupPath
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "Items.xls"
    txtFile.Text = GetSetting("howto_write_excel", "Settings", "File", file_name)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SaveSetting "howto_write_excel", "Settings", "File", txtFile.Text
End Sub

' Write into the Excel workbook.
Private Sub cmdWrite_Click()
Dim excel_app As Excel.Application
Dim workbook As Excel.workbook
Dim sheet_name As String
Dim sheet As Excel.Worksheet
Dim header_range As Excel.Range
Dim values(1 To 4, 1 To 3) As Integer
Dim value_range As Excel.Range

    ' Get the Excel application object.
    Set excel_app = New Excel.Application

    ' Make Excel visible (optional).
    excel_app.Visible = True

    ' Open the workbook.
    Set workbook = excel_app.Workbooks.Open(Filename:=txtFile.Text)

    ' See if the worksheet already exists.
    sheet_name = Format$(Date, "MM-dd-yy")

    Set sheet = FindSheet(workbook, sheet_name)
    If (sheet Is Nothing) Then
        ' Add the worksheet at the end.
        Set sheet = workbook.Sheets.Add( _
            After:=workbook.Sheets(workbook.Sheets.Count), _
            Count:=1, _
            Type:=Excel.XlSheetType.xlWorksheet)
        sheet.Name = sheet_name
    End If

    ' Add some data to individual cells.
    sheet.Cells(1, 1) = "A"
    sheet.Cells(1, 2) = "B"
    sheet.Cells(1, 3) = "C"

    ' Make that range of cells bold and red.
    Set header_range = sheet.Range("A1", "C1")
    header_range.Font.Bold = True
    header_range.Font.Color = vbRed
    header_range.Interior.Color = RGB(255, 128, 128)

    ' Add some data to a range of cells.
    values(1, 1) = 2
    values(1, 2) = 4
    values(1, 3) = 6
    values(2, 1) = 3
    values(2, 2) = 6
    values(2, 3) = 9
    values(3, 1) = 4
    values(3, 2) = 8
    values(3, 3) = 12
    values(4, 1) = 5
    values(4, 2) = 10
    values(4, 3) = 15
    Set value_range = sheet.Range("A2", "C5")
    value_range.Value2 = values

    ' Save the changes and close the workbook.
    workbook.Close SaveChanges:=True

    ' Close the Excel server.
    excel_app.Quit

    MsgBox "Done"
End Sub

' Return the worksheet with the given name.
Private Function FindSheet(ByVal workbook As Excel.workbook, ByVal sheet_name As String) As Excel.Worksheet
Dim sheet As Excel.Worksheet

    For Each sheet In workbook.Sheets
        If (sheet.Name = sheet_name) Then
            Set FindSheet = sheet
            Exit Function
        End If
    Next sheet

    Set FindSheet = Nothing
End Function

